<script lang="ts">
  import { onMount } from 'svelte';

  import { toggleTheme } from '@/utils';
  import { isDarkMode, updateHtmlHead } from '@/utils';

  import gitlabLogo from '@/assets/gitlab.svg';

  let repo_url = 'https://gitlab.com';
  if (import.meta.env.VITE_REPO_URL) {
    repo_url = import.meta.env.VITE_REPO_URL;
  }

  onMount(() => {
    updateHtmlHead(isDarkMode());
  });
  /**
   * Toggle the theme and update the logo
   * @returns {void}
   */
  const onThemeToggle = (): void => {
    const isDark = isDarkMode();
    toggleTheme();
    const repoLogo = document.getElementById('repo-logo');
    if (repoLogo) {
      repoLogo.style.filter = `invert(${isDark ? 0 : 1})`;
    }
  };
</script>

<div class="top-bar">
  <div>
    <div class="theme-toggle-wrapper">
      <div
        role="button"
        aria-pressed="false"
        aria-label="Toggle theme"
        id="theme-toggle"
        tabindex="0"
        on:click={onThemeToggle}
        on:keydown={() => null}
      >
        <div
          id="toggle-icon-light"
          style="background-color: {isDarkMode() ? 'transparent' : 'currentcolor'}"
        >
          <i class="fas fa-sun" />
        </div>
        <div id="toggle-icon-between" />
        <div
          id="toggle-icon-dark"
          style="background-color: {isDarkMode() ? 'currentcolor' : 'transparent'}"
        >
          <i class="fas fa-moon" />
        </div>
      </div>
    </div>
    <div class="repo-wrapper">
      <a href={repo_url} target="_blank" rel="noopener noreferrer" title="Gitlab repository">
        <img
          id="repo-logo"
          style="height: 1.5rem;{isDarkMode() ? 'filter: invert(1);' : ''}"
          width="24"
          height="24"
          src={gitlabLogo}
          alt="GitLab"
        />
      </a>
    </div>
  </div>
</div>
<div style="display:flex;flex-direction: column;">
  <slot />
</div>

<style>
  .top-bar {
    height: 50px;
    display: flex;
    align-items: end;
  }
</style>
